Imports PISOCANCPM_Net

Public Class Form1

    Dim BOARD As Byte
    Dim PORT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte

    Dim BlockMode As Byte = 1

    Dim RxSDO_Str As String = ""
    Dim TxSDO_Str As String = ""
    Dim RxPDO_Str As String = ""
    Dim TxPDO_Str As String = ""

    Dim RSDOISR As PISOCANCPM.ReadSDOISR
    Dim WSDOISR As PISOCANCPM.WriteSDOISR
    Dim RXPDOISR As PISOCANCPM.RxPDOISR
    Dim REMOTEPDOISR As PISOCANCPM.RemotePDOISR

    Dim ret As UInt16
    Dim errstr As String

    Sub UserRSDOISR()
        Dim Ret As UShort, Index As UShort
        Dim BoardNo As Byte, Port As Byte, SubIndex As Byte, RLen As Byte
        Dim RData(4) As Byte
        Dim Abort As UInteger

        Ret = PISOCANCPM.CPM_GetMasterReadSDOEvent(BoardNo, Port, Index, SubIndex)
        If Ret = 0 Then
            Select Case (Index)
                Case &H6000 ' Read DI (For CANopen SPC 401)
                    Dim DI_Value As Byte = 0

                    Select Case (SubIndex)
                        Case &H0
                            ' DI entry number
                            RLen = 1
                            RData(0) = &H2  ' Ex: ch0~ch15, total 2-bytes (16-bits) DI data.
                        Case &H1
                            RLen = 1
                            DI_Value = 0

                            ' Read DI value of ch0 ~ ch7
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Read DI Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                            RData(0) = DI_Value
                        Case &H2
                            RLen = 1
                            DI_Value = 0

                            ' Read DI value of ch8 ~ ch15
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Read DI Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                            RData(0) = DI_Value
                        Case Else
                            Abort = &H6090011

                            ' Abort: Sub-index does not exist.
                            RLen = 4
                            RData = BitConverter.GetBytes(Abort)
                    End Select
                Case &H6200 ' Read DO  (For CANopen SPC 401)
                    Dim DO_Value As Byte = 0

                    Select Case (SubIndex)
                        Case &H0
                            ' DO entry number
                            RLen = 1
                            RData(0) = &H2  ' Ex: ch0~ch15, total 2-bytes (16-bits) DO data.
                        Case &H1
                            RLen = 1
                            DO_Value = 0

                            ' Read DO value of ch0 ~ ch7
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Read DO Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                            RData(0) = DO_Value
                        Case &H2
                            RLen = 1
                            DO_Value = 0

                            ' Read DO value of ch8 ~ ch15
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Read DO Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                            RData(0) = DO_Value
                        Case Else
                            Abort = &H6090011

                            ' Abort: Sub-index does not exist.
                            RLen = 4
                            RData = BitConverter.GetBytes(Abort)
                    End Select
                Case Else
                    Abort = &H6020000

                    ' Abort: Object does not exist.
                    RLen = 4
                    RData = BitConverter.GetBytes(Abort)
            End Select


            Dim i As UShort
            Dim TempStr As String

            If (Abort = 0) Then
                PISOCANCPM.CPM_ResponseMasterSDO(BoardNo, Port, 0, Index, SubIndex, RLen, RData)
                TempStr = "SDO Read"

            Else
                PISOCANCPM.CPM_SDOAbortTransmit(BoardNo, Port, NODE, Index, SubIndex, Abort, BlockMode)
                TempStr = "SDO Abort"
            End If

            TempStr = TempStr + " " + Index.ToString("X4") + "-" + SubIndex.ToString("X2") + ":"

            If RLen <> 0 Then
                For i = 0 To RLen - 1

                    TempStr = TempStr + " " + RData(i).ToString("X2")
                Next i
            End If

            TxSDO_Str = TempStr
        End If
    End Sub

    Sub UserWSDOISR()
        Dim Ret As UShort, Index As UShort
        Dim BoardNo As Byte, Port As Byte, SubIndex As Byte, WLen As Byte
        Dim WData(4) As Byte
        Dim Abort As UInteger

        Ret = PISOCANCPM.CPM_GetMasterWriteSDOEvent(BoardNo, Port, Index, SubIndex, WLen, WData)
        If Ret = 0 Then
            Select Case (Index)
                Case &H6200 ' Write DO (For CANopen SPC 401)
                    If (WLen <> 1) Then
                        Abort = &H6070010

                        ' Abort: Data type does not match, length of service parameter does not match
                        WLen = 4
                        WData = BitConverter.GetBytes(Abort)
                    End If

                    Select Case (SubIndex)
                        Case &H0
                            Abort = &H6010002

                            ' Abort: Attempt to write a read only object
                            WLen = 4
                            WData = BitConverter.GetBytes(Abort)
                        Case &H1
                            ' Output DO value of ch0 ~ ch7
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Output DO Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                        Case &H2
                            ' Output DO value of ch8 ~ ch15
                            ''''''''''''''''''''''''''''''''''''''''''''''
                            '  Write user's "Output DO Data function" here


                            ''''''''''''''''''''''''''''''''''''''''''''''
                        Case Else
                            Abort = &H6090011

                            ' Abort: Sub-index does not exist.
                            WLen = 4
                            WData = BitConverter.GetBytes(Abort)
                    End Select
                Case Else
                    Abort = &H6090011

                    ' Abort: Object does not exist.
                    WLen = 4
                    WData = BitConverter.GetBytes(Abort)
            End Select

            Dim i As UShort
            Dim TempStr As String

            If (Abort = 0) Then
                PISOCANCPM.CPM_ResponseMasterSDO(BoardNo, Port, 0, Index, SubIndex, WLen, WData)
                TempStr = "SDO Write " + Index.ToString("X4") + "-" + SubIndex.ToString("X2") + ":  OK"

            Else
                PISOCANCPM.CPM_SDOAbortTransmit(BoardNo, Port, NODE, Index, SubIndex, Abort, BlockMode)
                TempStr = "SDO Abort " + Index.ToString("X4") + "-" + SubIndex.ToString("X2") + ":"

                If WLen <> 0 Then
                    For i = 0 To WLen - 1

                        TempStr = TempStr + " " + WData(i).ToString("X2")
                    Next i
                End If
            End If

            RxSDO_Str = TempStr
        End If
    End Sub

    Sub UserRXPDOISR()
        Dim Ret As UShort
        Dim BoardNo As Byte, Port As Byte, WLen As Byte
        Dim CobId As UShort, i As UShort
        Dim WData(8) As Byte
        Dim TempStr As String

        Ret = PISOCANCPM.CPM_GetMasterRxPDOEvent(BoardNo, PORT, CobId, WLen, WData)
        If Ret = 0 Then
            If (CobId = (&H200 + NODE)) Then
                If (WLen >= 2) Then ' Ex: If user has 2-bytes DO data.

                    ' Output DO value of ch0 ~ ch15
                    ''''''''''''''''''''''''''''''''''''''''''''''
                    '  Write user's "Output DO Data function" here


                    ''''''''''''''''''''''''''''''''''''''''''''''

                    TempStr = "PDO " + CobId.ToString("X3") + " Output:"
                    If WLen <> 0 Then
                        For i = 0 To WLen - 1
                            TempStr = TempStr + " " + WData(i).ToString("X2")
                        Next i
                    End If

                    RxPDO_Str = TempStr
                End If
            End If
        End If
    End Sub

    Sub UserREMOTEPDOISR()
        Dim Ret As UShort
        Dim BoardNo As Byte, Port As Byte, RLen As Byte
        Dim CobId As UShort, i As UShort
        Dim RData(8) As Byte
        Dim TempStr As String

        Ret = PISOCANCPM.CPM_GetMasterRemotePDOEvent(BoardNo, Port, CobId)
        If Ret = 0 Then
            If CobId = (&H180 + NODE) Then
                ' Ex: If user has 2-bytes DI data.
                RLen = 2

                ' Read DI value of ch0 ~ ch15
                ''''''''''''''''''''''''''''''''''''''''''''''
                '  Write user's "Read DI Data function" here


                ''''''''''''''''''''''''''''''''''''''''''''''

                TempStr = "PDO " + CobId.ToString("X3") + " Remote:"

                If RLen <> 0 Then
                    For i = 0 To RLen - 1
                        TempStr = TempStr + " " + RData(i).ToString("X2")
                    Next i
                End If

                TxPDO_Str = TempStr
            End If
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BOARD = 0
        PORT = 1
        BAUD = 0
        NODE = 1

        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = True

        Combo_Board.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0

        RSDOISR = New PISOCANCPM.ReadSDOISR(AddressOf UserRSDOISR)
        WSDOISR = New PISOCANCPM.WriteSDOISR(AddressOf UserWSDOISR)
        RXPDOISR = New PISOCANCPM.RxPDOISR(AddressOf UserRXPDOISR)
        REMOTEPDOISR = New PISOCANCPM.RemotePDOISR(AddressOf UserREMOTEPDOISR)

        Btn_Clear.Enabled = False

    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Call PISOCANCPM.CPM_ShutdownMaster(BOARD, PORT)
    End Sub

    Private Sub Combo_Com_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Board.SelectedIndexChanged
        BOARD = Combo_Board.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        BAUD = Combo_Baud.SelectedIndex
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        NODE = Combo_Node.SelectedIndex + 1
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click
        Dim Entry_Data(8) As UInt32

        ret = PISOCANCPM.CPM_InitMaster(BOARD, PORT, NODE, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Board.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            ' Install SDO read ISR
            ret = PISOCANCPM.CPM_InstallReadSDOISR(BOARD, PORT, RSDOISR)
            If ret <> 0 Then
                errstr = "Install Read SDO ISR Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            End If

            ' Initial SDO write ISR
            ret = PISOCANCPM.CPM_InstallWriteSDOISR(BOARD, PORT, WSDOISR)
            If ret <> 0 Then
                errstr = "Install Write SDO ISR Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            End If

            ' Install PDO output ISR
            ret = PISOCANCPM.CPM_InstallRxPDOISR(BOARD, PORT, RXPDOISR)
            If ret <> 0 Then
                errstr = "Install output PDO ISR Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            End If

            ' The "EntryUse" parameter and "EntryData" parameter are useless
            ' when the PDO had been installed to master. 
            Call PISOCANCPM.CPM_InstallPDO_List(BOARD, PORT, NODE, &H200 + NODE, 0, 1, 255, 0, 0, Entry_Data, BlockMode)

            ' Install PDO remote ISR
            ret = PISOCANCPM.CPM_InstallRemotePDOISR(BOARD, PORT, REMOTEPDOISR)
            If ret <> 0 Then
                errstr = "Install remote PDO ISR Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            End If

            ' The "EntryUse" parameter and "EntryData" parameter are useless
            ' when the PDO had been installed to master.
            Call PISOCANCPM.CPM_InstallPDO_List(BOARD, PORT, NODE, &H180 + NODE, 1, 1, 255, 0, 0, Entry_Data, BlockMode)

            timer1.Enabled = True

        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click

        ret = PISOCANCPM.CPM_ShutdownMaster(BOARD, PORT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Board.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Combo_Node.SelectedIndex = 0

            List_Monitor.Items.Clear()

            timer1.Enabled = False
        End If
    End Sub

    Private Sub Btn_Clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Clear.Click
        List_Monitor.Items.Clear()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick

        If (RxSDO_Str <> "") Then
            List_Monitor.Items.Add(RxSDO_Str)
            RxSDO_Str = ""
        End If

        If (TxSDO_Str <> "") Then
            List_Monitor.Items.Add(TxSDO_Str)
            TxSDO_Str = ""
        End If

        If (RxPDO_Str <> "") Then
            List_Monitor.Items.Add(RxPDO_Str)
            RxPDO_Str = ""
        End If

        If (TxPDO_Str <> "") Then
            List_Monitor.Items.Add(TxPDO_Str)
            TxPDO_Str = ""
        End If

    End Sub
End Class
